libzypp: zypp::ZConfig Class Reference

libzypp 17.38.14

zypp::ZConfig Class Reference
Zypp Configuration Options

Interim helper class to collect global options and settings. More...

`#include <zypp/ZConfig.h>`

Inheritance diagram for zypp::ZConfig:

## Classes
class | Impl
| ZConfig implementation. More...

## Public Member Functions
std::ostream & | about (std::ostream &str) const
| Print some detail about the current libzypp version.
long | lockTimeout () const
| The number of seconds to wait for the zypp lock to become available.
Pathname | systemRoot () const
| The target root directory.
Pathname | repoManagerRoot () const
| The RepoManager root directory.
void | setRepoManagerRoot (const Pathname &root)
| Sets the RepoManager root directory.
void | announceSystemRoot (const Pathname &root_r)
| Announce a target root directory without launching the Target.
Arch | systemArchitecture () const
| The system architecture zypp uses.
void | setSystemArchitecture (const Arch &arch_r)
| Override the zypp system architecture.
void | resetSystemArchitecture ()
| Reset the zypp system architecture to the default.
Locale | textLocale () const
| The locale for translated texts zypp uses.
void | setTextLocale (const Locale &locale_r)
| Set the preferred locale for translated texts.
void | resetTextLocale ()
| Reset the locale for translated texts to the default.
Maintain user data
See also User data as transaction id
bool | hasUserData () const
| Whether a (non empty) user data sting is defined.
std::string | userData () const
| User defined string value to be passed to log, history, plugins...
bool | setUserData (const std::string &str_r)
| Set a new userData string.
Pathname | repoCachePath () const
| Path where the caches are kept (/var/cache/zypp).
void | setRepoCachePath (const Pathname &path_r)
| Set a new path as the default repo cache path.
Pathname | pubkeyCachePath () const
| Path where the pubkey caches.
Pathname | repoMetadataPath () const
| Path where the repo metadata is downloaded and kept (repoCachePath()/raw).
void | setRepoMetadataPath (const Pathname &path_r)
| Set a new path as the default repo cache path.
Pathname | repoSolvfilesPath () const
| Path where the repo solv files are created and kept (repoCachePath()/solv).
void | setRepoSolvfilesPath (const Pathname &path_r)
| Set a new path as the default repo cache path.
Pathname | repoPackagesPath () const
| Path where the repo packages are downloaded and kept (repoCachePath()/packages).
void | setRepoPackagesPath (const Pathname &path_r)
| Set a new path as the default repo cache path.
Pathname | configPath () const
| Path where the configfiles are kept (/etc/zypp).
Pathname | knownReposPath () const
| Path where the known repositories .repo files are kept (configPath()/repos.d).
Pathname | knownServicesPath () const
| Path where the known services .service files are kept (configPath()/services.d).
Pathname | needrebootFile () const
| Path of the default needreboot config file (configPath()/needreboot).
Pathname | needrebootPath () const
| Path where the custom needreboot config files are kept (configPath()/needreboot.d).
void | setGeoipEnabled (bool enable=true)
| Enables or disables the use of the geoip feature of download.opensuse.org.
bool | geoipEnabled () const
| Returns true if zypp should use the geoip feature of download.opensuse.org.
Pathname | geoipCachePath () const
| Path where the geoip caches are kept (/var/cache/zypp/geoip).
const std::vector< std::string > | geoipHostnames () const
| All hostnames we want to rewrite using the geoip feature.
Pathname | varsPath () const
| Path containing custom repo variable definitions (configPath()/vars.d).
bool | repo_add_probe () const
| Whether repository urls should be probed.
unsigned | repo_refresh_delay () const
| Amount of time in minutes that must pass before another refresh.
LocaleSet | repoRefreshLocales () const
| List of locales for which translated package descriptions should be downloaded.
bool | repoLabelIsAlias () const
| Whether to use repository alias or name in user messages (progress, exceptions, ...).
void | repoLabelIsAlias (bool yesno_r)
| Whether to use repository alias or name in user messages (progress, exceptions, ...).
long | download_max_concurrent_connections () const
| Maximum number of concurrent connections for a single transfer.
long | download_min_download_speed () const
| Minimum download speed (bytes per second) until the connection is dropped.
long | download_max_download_speed () const
| Maximum download speed (bytes per second).
long | download_max_silent_tries () const
| Maximum silent tries.
long | download_transfer_timeout () const
| Maximum time in seconds that you allow a transfer operation to take.
bool | download_use_deltarpm () const
| Whether to consider using a deltarpm when downloading a package.
bool | download_use_deltarpm_always () const
| Whether to consider using a deltarpm even when rpm is local.
bool | download_media_prefer_download () const
| Hint which media to prefer when installing packages (download vs.
bool | download_media_prefer_volatile () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | set_download_media_prefer_download (bool yesno_r)
| Set download_media_prefer_download to a specific value.
void | set_default_download_media_prefer_download ()
| Set download_media_prefer_download to the configfiles default.
Pathname | download_mediaMountdir () const
| Path where media are preferably mounted or downloaded.
void | set_download_mediaMountdir (Pathname newval_r)
| Set alternate value.
void | set_default_download_mediaMountdir ()
| Reset to zypp.cong default.
DownloadMode | commit_downloadMode () const
| Commit download policy to use as default.
Signature checking (repodata and packages)
If gpgcheck is `on` (the default), we will either check the signature of repo metadata (packages are secured via checksum in the metadata), or the signature of an rpm package to install if its repo metadata is not signed or not checked. If gpgcheck is `off`, no checks are performed. The default behavior can be altered by explicitly setting repo_gpgcheck and/or pkg_gpgcheck to perform those checks always (`on`) or never (`off`). Explicitly setting `gpgcheck`, `repo_gpgcheck` or `pkg_gpgcheck` in a repositories .repo file will overwrite the defaults here.
bool | gpgCheck () const
| Turn signature checking on/off (on).
TriBool | repoGpgCheck () const
| Check repo matadata signatures (indeterminate - according to gpgcheck).
TriBool | pkgGpgCheck () const
| Check rpm package signatures (indeterminate - according to gpgcheck).
void | setGpgCheck (bool val_r)
| Change the value.
void | setRepoGpgCheck (TriBool val_r)
| Change the value.
void | setPkgGpgCheck (TriBool val_r)
| Change the value.
void | resetGpgCheck ()
| Reset to the zconfig default.
void | resetRepoGpgCheck ()
| Reset to the zconfig default.
void | resetPkgGpgCheck ()
| Reset to the zconfig default.
Pathname | vendorPath () const
| Directory for equivalent vendor definitions (configPath()/vendors.d).
ResolverFocus | solver_focus () const
| The resolver's general attitude when resolving jobs.
bool | solver_onlyRequires () const
| Solver regards required packages,patterns,... only.
Pathname | solver_checkSystemFile () const
| File in which dependencies described which has to be fulfilled for a running system.
Pathname | solver_checkSystemFileDir () const
| Directory, which may or may not contain files in which dependencies described which has to be fulfilled for a running system.
bool | solver_allowVendorChange () const
| Whether vendor check is by default enabled.
bool | solver_dupAllowDowngrade () const
| DUP tune: Whether to allow version downgrades upon DUP.
bool | solver_dupAllowNameChange () const
| DUP tune: Whether to follow package renames upon DUP.
bool | solver_dupAllowArchChange () const
| DUP tune: Whether to allow package arch changes upon DUP.
bool | solver_dupAllowVendorChange () const
| DUP tune: Whether to allow package vendor changes upon DUP.
bool | solver_cleandepsOnRemove () const
| Whether removing a package should also remove no longer needed requirements.
bool | solver_noUpdateProvide () const
| Do not prefer update candidates also providing the old package.
unsigned | solver_upgradeTestcasesToKeep () const
| When committing a dist upgrade (e.g.
bool | solverUpgradeRemoveDroppedPackages () const
| Whether dist upgrade should remove a products dropped packages (true).
void | setSolverUpgradeRemoveDroppedPackages (bool val_r)
| Set solverUpgradeRemoveDroppedPackages to val_r.
void | resetSolverUpgradeRemoveDroppedPackages ()
| Reset solverUpgradeRemoveDroppedPackages to the `zypp.conf` default.
Command to be invoked to send update messages.
std::string | updateMessagesNotify () const
| Command definition for sending update messages.
void | setUpdateMessagesNotify (const std::string &val_r)
| Set a new command definition (see update.messages.notify in zypp.conf).
void | resetUpdateMessagesNotify ()
| Reset to the zypp.conf default.
Options for package installation
target::rpm::RpmInstFlags | rpmInstallFlags () const
| The default target::rpm::RpmInstFlags for ZYppCommitPolicy.
Pathname | historyLogFile () const
| Path where ZYpp install history is logged.
Pathname | credentialsGlobalDir () const
| Defaults to /etc/zypp/credentials.d.
Pathname | credentialsGlobalFile () const
| Defaults to /etc/zypp/credentials.cat.
std::string | distroverpkg () const
| Package telling the "product version" on systems not using /etc/product.d/baseproduct.

## Static Public Member Functions
static ZConfig & | instance ()
| Singleton ctor.
static Arch | defaultSystemArchitecture ()
| The autodetected system architecture.
static Locale | defaultTextLocale ()
| The autodetected preferred locale for translated texts.

## Plugins
class | RepoManager
class | zyppng::RepoManager
class | Impl
RW_pointer< Impl, rw_pointer::Scoped< Impl > > | _pimpl
| Pointer to implementation.
Pathname | pluginsPath () const
| Defaults to `/usr/lib/zypp/plugins`.
std::string | multiversionKernels () const
| ZConfig (const ZConfig &)=delete
| ZConfig (ZConfig &&)=delete
ZConfig & | operator= (const ZConfig &)=delete
ZConfig & | operator= (ZConfig &&)=delete
| ~ZConfig ()
| Dtor.
void | notifyTargetChanged ()
| internal
Pathname | builtinRepoCachePath () const
| The builtin config file value.
Pathname | builtinRepoMetadataPath () const
| The builtin config file value.
Pathname | builtinRepoSolvfilesPath () const
| The builtin config file value.
Pathname | builtinRepoPackagesPath () const
| The builtin config file value.
| ZConfig ()
| Default ctor.

## Packages which can be installed in different versions at the same time.
This returns the config file values (`names` or `provides:`...). The corresponding packages have the `multiversionInstall` property set. Those packages will be installed using 'rpm -i', so they will not implicitly obsolete other installed versions. See also sat::SolvableType
static Pathname | update_dataPath ()
| Path where the update items are kept (/var/adm).
static Pathname | update_scriptsPath ()
| Path where the update scripts are stored ( /var/adm/update-scripts ).
static Pathname | update_messagesPath ()
| Path where the update messages are stored ( /var/adm/update-messages ).
const std::set< std::string > & | multiversionSpec () const
void | multiversionSpec (std::set< std::string > new_r)
void | clearMultiversionSpec ()
void | addMultiversionSpec (const std::string &name_r)
void | removeMultiversionSpec (const std::string &name_r)
Pathname | locksFile () const
| Path where zypp can find or create lock file (configPath()/locks).
bool | apply_locks_file () const
| Whether locks file should be read and applied after start (true).

## Detailed Description

Interim helper class to collect global options and settings.

Use it to avoid hardcoded values and calls to getZYpp() just to retrieve some value like architecture, languages or temppath.

Configuration data are obtained from the following sources in the following order:

1. An applications explicit settings
2. system-wide configuration files (/etc/zypp/zypp.conf[.d/*.conf])
3. ephermal configuration files (/run/zypp/zypp.conf[.d/*.conf])
4. vendor configuration files (/usr/etc/zypp/zypp.conf[.d/*.conf])

The rules are defined by the UAPI.6 Configuration Files Specification (version 1)[1], but may be changed to follow newer versions in the future.

See also
  [1] https://github.com/uapi-group/specifications/blob/main/specs/configuration_files_specification.md and the ZYPP.CONF(5) manpage for more details.

Setting the `ZYPP_CONF` environment variable will disable the above and solely parse the denoted file so it exists.

Config values for MediaConfig are forwarded to the MediaConfig singleton.

Note, if you add settings to this file, please follow the following convention:

namespace.settingname

should become

namespace_settingName()

Definition at line 81 of file ZConfig.h.

## Constructor & Destructor Documentation

## ◆ ZConfig() [1/3]

zypp::ZConfig::ZConfig | ( | const ZConfig & |  | ) |
| delete

## ◆ ZConfig() [2/3]

zypp::ZConfig::ZConfig | ( | ZConfig && |  | ) |
| delete

## ◆ ~ZConfig()

zypp::ZConfig::~ZConfig | ( |  | ) |

Dtor.

Definition at line 816 of file ZConfig.cc.

## ◆ ZConfig() [3/3]

zypp::ZConfig::ZConfig | ( |  | ) |
| private

Default ctor.

Definition at line 805 of file ZConfig.cc.

## Member Function Documentation

## ◆ instance()

ZConfig & zypp::ZConfig::instance | ( |  | ) |
| static

Singleton ctor.

Definition at line 794 of file ZConfig.cc.

## ◆ about()

std::ostream & zypp::ZConfig::about | ( | std::ostream & | str | ) | const

Print some detail about the current libzypp version.

Definition at line 1222 of file ZConfig.cc.

## ◆ lockTimeout()

long zypp::ZConfig::lockTimeout | ( |  | ) | const

The number of seconds to wait for the zypp lock to become available.

Definition at line 819 of file ZConfig.cc.

## ◆ systemRoot()

Pathname zypp::ZConfig::systemRoot | ( |  | ) | const

The target root directory.

Returns an empty path if no target is set.

Definition at line 831 of file ZConfig.cc.

## ◆ repoManagerRoot()

Pathname zypp::ZConfig::repoManagerRoot | ( |  | ) | const

The RepoManager root directory.

Returns the same as systemRoot() if not explicitly set.

Definition at line 834 of file ZConfig.cc.

## ◆ setRepoManagerRoot()

void zypp::ZConfig::setRepoManagerRoot | ( | const Pathname & | root | ) |

Sets the RepoManager root directory.

See also
  repoManagerRoot()

Definition at line 840 of file ZConfig.cc.

## ◆ announceSystemRoot()

void zypp::ZConfig::announceSystemRoot | ( | const Pathname & | root_r | ) |

Announce a target root directory without launching the Target.

This can be used by workflows which want to run —root but without immediately launching the Target. The value is cleared as soon as a real Target is up.

Definition at line 843 of file ZConfig.cc.

## ◆ defaultSystemArchitecture()

Arch zypp::ZConfig::defaultSystemArchitecture | ( |  | ) |
| static

The autodetected system architecture.

Definition at line 852 of file ZConfig.cc.

## ◆ systemArchitecture()

Arch zypp::ZConfig::systemArchitecture | ( |  | ) | const

The system architecture zypp uses.

Definition at line 857 of file ZConfig.cc.

## ◆ setSystemArchitecture()

void zypp::ZConfig::setSystemArchitecture | ( | const Arch & | arch_r | ) |

Override the zypp system architecture.

This is useful for test scenarious. But be warned, zypp does not expect the system architecture to change at runtime. So set it at the very beginning before you access any other zypp component.

Definition at line 860 of file ZConfig.cc.

## ◆ resetSystemArchitecture()

void zypp::ZConfig::resetSystemArchitecture | ( |  | ) |
| inline

Reset the zypp system architecture to the default.

Definition at line 136 of file ZConfig.h.

## ◆ defaultTextLocale()

Locale zypp::ZConfig::defaultTextLocale | ( |  | ) |
| static

The autodetected preferred locale for translated texts.

Definition at line 875 of file ZConfig.cc.

## ◆ textLocale()

Locale zypp::ZConfig::textLocale | ( |  | ) | const

The locale for translated texts zypp uses.

Definition at line 881 of file ZConfig.cc.

## ◆ setTextLocale()

void zypp::ZConfig::setTextLocale | ( | const Locale & | locale_r | ) |

Set the preferred locale for translated texts.

Definition at line 884 of file ZConfig.cc.

## ◆ resetTextLocale()

void zypp::ZConfig::resetTextLocale | ( |  | ) |
| inline

Reset the locale for translated texts to the default.

Definition at line 152 of file ZConfig.h.

## ◆ hasUserData()

bool zypp::ZConfig::hasUserData | ( |  | ) | const

Whether a (non empty) user data sting is defined.

Definition at line 899 of file ZConfig.cc.

## ◆ userData()

std::string zypp::ZConfig::userData | ( |  | ) | const

User defined string value to be passed to log, history, plugins...

Definition at line 902 of file ZConfig.cc.

## ◆ setUserData()

bool zypp::ZConfig::setUserData | ( | const std::string & | str_r | ) |

Set a new userData string.

Returns
  `TRUE` if the string was accepted; `FALSE` if the string was rejected due to nonprintable characters or newlines.

Definition at line 905 of file ZConfig.cc.

## ◆ repoCachePath()

Pathname zypp::ZConfig::repoCachePath | ( |  | ) | const

Path where the caches are kept (/var/cache/zypp).

Definition at line 922 of file ZConfig.cc.

## ◆ setRepoCachePath()

void zypp::ZConfig::setRepoCachePath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 933 of file ZConfig.cc.

## ◆ pubkeyCachePath()

Pathname zypp::ZConfig::pubkeyCachePath | ( |  | ) | const

Path where the pubkey caches.

Definition at line 928 of file ZConfig.cc.

## ◆ repoMetadataPath()

Pathname zypp::ZConfig::repoMetadataPath | ( |  | ) | const

Path where the repo metadata is downloaded and kept (repoCachePath()/raw).

Definition at line 938 of file ZConfig.cc.

## ◆ setRepoMetadataPath()

void zypp::ZConfig::setRepoMetadataPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 944 of file ZConfig.cc.

## ◆ repoSolvfilesPath()

Pathname zypp::ZConfig::repoSolvfilesPath | ( |  | ) | const

Path where the repo solv files are created and kept (repoCachePath()/solv).

Definition at line 949 of file ZConfig.cc.

## ◆ setRepoSolvfilesPath()

void zypp::ZConfig::setRepoSolvfilesPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 955 of file ZConfig.cc.

## ◆ repoPackagesPath()

Pathname zypp::ZConfig::repoPackagesPath | ( |  | ) | const

Path where the repo packages are downloaded and kept (repoCachePath()/packages).

Definition at line 960 of file ZConfig.cc.

## ◆ setRepoPackagesPath()

void zypp::ZConfig::setRepoPackagesPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 966 of file ZConfig.cc.

## ◆ configPath()

Pathname zypp::ZConfig::configPath | ( |  | ) | const

Path where the configfiles are kept (/etc/zypp).

Definition at line 985 of file ZConfig.cc.

## ◆ knownReposPath()

Pathname zypp::ZConfig::knownReposPath | ( |  | ) | const

Path where the known repositories .repo files are kept (configPath()/repos.d).

Definition at line 991 of file ZConfig.cc.

## ◆ knownServicesPath()

Pathname zypp::ZConfig::knownServicesPath | ( |  | ) | const

Path where the known services .service files are kept (configPath()/services.d).

Definition at line 997 of file ZConfig.cc.

## ◆ needrebootFile()

Pathname zypp::ZConfig::needrebootFile | ( |  | ) | const

Path of the default needreboot config file (configPath()/needreboot).

Definition at line 1003 of file ZConfig.cc.

## ◆ needrebootPath()

Pathname zypp::ZConfig::needrebootPath | ( |  | ) | const

Path where the custom needreboot config files are kept (configPath()/needreboot.d).

Definition at line 1006 of file ZConfig.cc.

## ◆ setGeoipEnabled()

void zypp::ZConfig::setGeoipEnabled | ( | bool | enable = true | ) |

Enables or disables the use of the geoip feature of download.opensuse.org.

Definition at line 1009 of file ZConfig.cc.

## ◆ geoipEnabled()

bool zypp::ZConfig::geoipEnabled | ( |  | ) | const

Returns true if zypp should use the geoip feature of download.opensuse.org.

Definition at line 1012 of file ZConfig.cc.

## ◆ geoipCachePath()

Pathname zypp::ZConfig::geoipCachePath | ( |  | ) | const

Path where the geoip caches are kept (/var/cache/zypp/geoip).

Definition at line 1015 of file ZConfig.cc.

## ◆ geoipHostnames()

const std::vector< std::string > zypp::ZConfig::geoipHostnames | ( |  | ) | const

All hostnames we want to rewrite using the geoip feature.

The RepoManager will try to query each hostname via: https://hostname/geoip to receive a redirection target for requests to the given hostname. The geoip targets are cached in geoipCachePath.

Definition at line 1018 of file ZConfig.cc.

## ◆ varsPath()

Pathname zypp::ZConfig::varsPath | ( |  | ) | const

Path containing custom repo variable definitions (configPath()/vars.d).

See also
  zypp::repo::RepoVarExpand Repo variable expander

Definition at line 1021 of file ZConfig.cc.

## ◆ repo_add_probe()

bool zypp::ZConfig::repo_add_probe | ( |  | ) | const

Whether repository urls should be probed.

/ config option repo.add.probe

Definition at line 1041 of file ZConfig.cc.

## ◆ repo_refresh_delay()

unsigned zypp::ZConfig::repo_refresh_delay | ( |  | ) | const

Amount of time in minutes that must pass before another refresh.

Definition at line 1044 of file ZConfig.cc.

## ◆ repoRefreshLocales()

LocaleSet zypp::ZConfig::repoRefreshLocales | ( |  | ) | const

List of locales for which translated package descriptions should be downloaded.

Definition at line 1047 of file ZConfig.cc.

## ◆ repoLabelIsAlias() [1/2]

bool zypp::ZConfig::repoLabelIsAlias | ( |  | ) | const

Whether to use repository alias or name in user messages (progress, exceptions, ...).

True: use alias, false: use name.

Definition at line 1050 of file ZConfig.cc.

## ◆ repoLabelIsAlias() [2/2]

void zypp::ZConfig::repoLabelIsAlias | ( | bool | yesno_r | ) |

Whether to use repository alias or name in user messages (progress, exceptions, ...).

Console applications might prefer to use and display the shorter alias instead of full repository name.

Default: false; i.e. repo label is 'name'

Definition at line 1053 of file ZConfig.cc.

## ◆ download_max_concurrent_connections()

long zypp::ZConfig::download_max_concurrent_connections | ( |  | ) | const

Maximum number of concurrent connections for a single transfer.

Definition at line 1071 of file ZConfig.cc.

## ◆ download_min_download_speed()

long zypp::ZConfig::download_min_download_speed | ( |  | ) | const

Minimum download speed (bytes per second) until the connection is dropped.

Definition at line 1074 of file ZConfig.cc.

## ◆ download_max_download_speed()

long zypp::ZConfig::download_max_download_speed | ( |  | ) | const

Maximum download speed (bytes per second).

Definition at line 1077 of file ZConfig.cc.

## ◆ download_max_silent_tries()

long zypp::ZConfig::download_max_silent_tries | ( |  | ) | const

Maximum silent tries.

Definition at line 1080 of file ZConfig.cc.

## ◆ download_transfer_timeout()

long zypp::ZConfig::download_transfer_timeout | ( |  | ) | const

Maximum time in seconds that you allow a transfer operation to take.

Definition at line 1083 of file ZConfig.cc.

## ◆ download_use_deltarpm()

bool zypp::ZConfig::download_use_deltarpm | ( |  | ) | const

Whether to consider using a deltarpm when downloading a package.

Config option download.use_deltarpm (true)

Definition at line 1056 of file ZConfig.cc.

## ◆ download_use_deltarpm_always()

bool zypp::ZConfig::download_use_deltarpm_always | ( |  | ) | const

Whether to consider using a deltarpm even when rpm is local.

This requires download_use_deltarpm being `true`. Config option download.use_deltarpm.always (false)

Definition at line 1059 of file ZConfig.cc.

## ◆ download_media_prefer_download()

bool zypp::ZConfig::download_media_prefer_download | ( |  | ) | const

Hint which media to prefer when installing packages (download vs.

CD).

See also
  class media::MediaPriority

Definition at line 1062 of file ZConfig.cc.

## ◆ download_media_prefer_volatile()

bool zypp::ZConfig::download_media_prefer_volatile | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 361 of file ZConfig.h.

## ◆ set_download_media_prefer_download()

void zypp::ZConfig::set_download_media_prefer_download | ( | bool | yesno_r | ) |

Set download_media_prefer_download to a specific value.

Definition at line 1065 of file ZConfig.cc.

## ◆ set_default_download_media_prefer_download()

void zypp::ZConfig::set_default_download_media_prefer_download | ( |  | ) |

Set download_media_prefer_download to the configfiles default.

Definition at line 1068 of file ZConfig.cc.

## ◆ download_mediaMountdir()

Pathname zypp::ZConfig::download_mediaMountdir | ( |  | ) | const

Path where media are preferably mounted or downloaded.

Config option download.media_mountdir (/var/adm/mount) Needs to be a (writable) directory, otherwise /var/tmp is fallback.

Definition at line 1086 of file ZConfig.cc.

## ◆ set_download_mediaMountdir()

void zypp::ZConfig::set_download_mediaMountdir | ( | Pathname | newval_r | ) |

Set alternate value.

Definition at line 1087 of file ZConfig.cc.

## ◆ set_default_download_mediaMountdir()

void zypp::ZConfig::set_default_download_mediaMountdir | ( |  | ) |

Reset to zypp.cong default.

Definition at line 1088 of file ZConfig.cc.

## ◆ commit_downloadMode()

DownloadMode zypp::ZConfig::commit_downloadMode | ( |  | ) | const

Commit download policy to use as default.

Definition at line 1090 of file ZConfig.cc.

## ◆ gpgCheck()

bool zypp::ZConfig::gpgCheck | ( |  | ) | const

Turn signature checking on/off (on).

Definition at line 1094 of file ZConfig.cc.

## ◆ repoGpgCheck()

TriBool zypp::ZConfig::repoGpgCheck | ( |  | ) | const

Check repo matadata signatures (indeterminate - according to gpgcheck).

Definition at line 1095 of file ZConfig.cc.

## ◆ pkgGpgCheck()

TriBool zypp::ZConfig::pkgGpgCheck | ( |  | ) | const

Check rpm package signatures (indeterminate - according to gpgcheck).

Definition at line 1096 of file ZConfig.cc.

## ◆ setGpgCheck()

void zypp::ZConfig::setGpgCheck | ( | bool | val_r | ) |

Change the value.

Definition at line 1098 of file ZConfig.cc.

## ◆ setRepoGpgCheck()

void zypp::ZConfig::setRepoGpgCheck | ( | TriBool | val_r | ) |

Change the value.

Definition at line 1099 of file ZConfig.cc.

## ◆ setPkgGpgCheck()

void zypp::ZConfig::setPkgGpgCheck | ( | TriBool | val_r | ) |

Change the value.

Definition at line 1100 of file ZConfig.cc.

## ◆ resetGpgCheck()

void zypp::ZConfig::resetGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1102 of file ZConfig.cc.

## ◆ resetRepoGpgCheck()

void zypp::ZConfig::resetRepoGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1103 of file ZConfig.cc.

## ◆ resetPkgGpgCheck()

void zypp::ZConfig::resetPkgGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1104 of file ZConfig.cc.

## ◆ vendorPath()

Pathname zypp::ZConfig::vendorPath | ( |  | ) | const

Directory for equivalent vendor definitions (configPath()/vendors.d).

Definition at line 1027 of file ZConfig.cc.

## ◆ solver_focus()

ResolverFocus zypp::ZConfig::solver_focus | ( |  | ) | const

The resolver's general attitude when resolving jobs.

Definition at line 1107 of file ZConfig.cc.

## ◆ solver_onlyRequires()

bool zypp::ZConfig::solver_onlyRequires | ( |  | ) | const

Solver regards required packages,patterns,... only.

Definition at line 1108 of file ZConfig.cc.

## ◆ solver_checkSystemFile()

Pathname zypp::ZConfig::solver_checkSystemFile | ( |  | ) | const

File in which dependencies described which has to be fulfilled for a running system.

Definition at line 1123 of file ZConfig.cc.

## ◆ solver_checkSystemFileDir()

Pathname zypp::ZConfig::solver_checkSystemFileDir | ( |  | ) | const

Directory, which may or may not contain files in which dependencies described which has to be fulfilled for a running system.

Definition at line 1127 of file ZConfig.cc.

## ◆ solver_allowVendorChange()

bool zypp::ZConfig::solver_allowVendorChange | ( |  | ) | const

Whether vendor check is by default enabled.

Definition at line 1109 of file ZConfig.cc.

## ◆ solver_dupAllowDowngrade()

bool zypp::ZConfig::solver_dupAllowDowngrade | ( |  | ) | const

DUP tune: Whether to allow version downgrades upon DUP.

Definition at line 1111 of file ZConfig.cc.

## ◆ solver_dupAllowNameChange()

bool zypp::ZConfig::solver_dupAllowNameChange | ( |  | ) | const

DUP tune: Whether to follow package renames upon DUP.

Definition at line 1112 of file ZConfig.cc.

## ◆ solver_dupAllowArchChange()

bool zypp::ZConfig::solver_dupAllowArchChange | ( |  | ) | const

DUP tune: Whether to allow package arch changes upon DUP.

Definition at line 1113 of file ZConfig.cc.

## ◆ solver_dupAllowVendorChange()

bool zypp::ZConfig::solver_dupAllowVendorChange | ( |  | ) | const

DUP tune: Whether to allow package vendor changes upon DUP.

Definition at line 1114 of file ZConfig.cc.

## ◆ solver_cleandepsOnRemove()

bool zypp::ZConfig::solver_cleandepsOnRemove | ( |  | ) | const

Whether removing a package should also remove no longer needed requirements.

Definition at line 1115 of file ZConfig.cc.

## ◆ solver_noUpdateProvide()

bool zypp::ZConfig::solver_noUpdateProvide | ( |  | ) | const

Do not prefer update candidates also providing the old package.

In general, packages that obsolete another package are treated as update candidates for the obsoleted package. However, SUSE-specific update rules prefer candidates that also explicitly 'provide' the obsoleted package.

Sometimes it is necessary or helpful to disable this rule.

Definition at line 1110 of file ZConfig.cc.

## ◆ solver_upgradeTestcasesToKeep()

unsigned zypp::ZConfig::solver_upgradeTestcasesToKeep | ( |  | ) | const

When committing a dist upgrade (e.g.

zypper dup) a solver testcase is written. It is needed in bugreports, in case something went wrong. This returns the number of testcases to keep on the system. Old cases will be deleted, as new ones are created. Use `0` to write no testcase at all.

Definition at line 1116 of file ZConfig.cc.

## ◆ solverUpgradeRemoveDroppedPackages()

bool zypp::ZConfig::solverUpgradeRemoveDroppedPackages | ( |  | ) | const

Whether dist upgrade should remove a products dropped packages (true).

A new product may suggest a list of old and no longer supported packages (dropped packages). Performing a dist upgrade the solver may try to delete them, even if they do not cause any dependency problem.

Turning this option off, the solver will not try to remove those packages unless they actually do cause dependency trouble. At any time you may use zypper to detect orphaned packages, and do the cleanup manually. Or simply leave them installed as long as you don't need the disk space.

Definition at line 1118 of file ZConfig.cc.

## ◆ setSolverUpgradeRemoveDroppedPackages()

void zypp::ZConfig::setSolverUpgradeRemoveDroppedPackages | ( | bool | val_r | ) |

Set solverUpgradeRemoveDroppedPackages to val_r.

Definition at line 1119 of file ZConfig.cc.

## ◆ resetSolverUpgradeRemoveDroppedPackages()

void zypp::ZConfig::resetSolverUpgradeRemoveDroppedPackages | ( |  | ) |

Reset solverUpgradeRemoveDroppedPackages to the `zypp.conf` default.

Definition at line 1120 of file ZConfig.cc.

## ◆ multiversionSpec() [1/2]

const std::set< std::string > & zypp::ZConfig::multiversionSpec | ( |  | ) | const

Definition at line 1141 of file ZConfig.cc.

## ◆ multiversionSpec() [2/2]

void zypp::ZConfig::multiversionSpec | ( | std::set< std::string > | new_r | ) |

Definition at line 1142 of file ZConfig.cc.

## ◆ clearMultiversionSpec()

void zypp::ZConfig::clearMultiversionSpec | ( |  | ) |

Definition at line 1143 of file ZConfig.cc.

## ◆ addMultiversionSpec()

void zypp::ZConfig::addMultiversionSpec | ( | const std::string & | name_r | ) |

Definition at line 1144 of file ZConfig.cc.

## ◆ removeMultiversionSpec()

void zypp::ZConfig::removeMultiversionSpec | ( | const std::string & | name_r | ) |

Definition at line 1145 of file ZConfig.cc.

## ◆ locksFile()

Pathname zypp::ZConfig::locksFile | ( |  | ) | const

Path where zypp can find or create lock file (configPath()/locks).

Definition at line 1033 of file ZConfig.cc.

## ◆ apply_locks_file()

bool zypp::ZConfig::apply_locks_file | ( |  | ) | const

Whether locks file should be read and applied after start (true).

Definition at line 1147 of file ZConfig.cc.

## ◆ update_dataPath()

Pathname zypp::ZConfig::update_dataPath | ( |  | ) |
| static

Path where the update items are kept (/var/adm).

Definition at line 1150 of file ZConfig.cc.

## ◆ update_scriptsPath()

Pathname zypp::ZConfig::update_scriptsPath | ( |  | ) |
| static

Path where the update scripts are stored ( /var/adm/update-scripts ).

Definition at line 1166 of file ZConfig.cc.

## ◆ update_messagesPath()

Pathname zypp::ZConfig::update_messagesPath | ( |  | ) |
| static

Path where the update messages are stored ( /var/adm/update-messages ).

Definition at line 1158 of file ZConfig.cc.

## ◆ updateMessagesNotify()

std::string zypp::ZConfig::updateMessagesNotify | ( |  | ) | const

Command definition for sending update messages.

Definition at line 1174 of file ZConfig.cc.

## ◆ setUpdateMessagesNotify()

void zypp::ZConfig::setUpdateMessagesNotify | ( | const std::string & | val_r | ) |

Set a new command definition (see update.messages.notify in zypp.conf).

Definition at line 1177 of file ZConfig.cc.

## ◆ resetUpdateMessagesNotify()

void zypp::ZConfig::resetUpdateMessagesNotify | ( |  | ) |

Reset to the zypp.conf default.

Definition at line 1180 of file ZConfig.cc.

## ◆ rpmInstallFlags()

target::rpm::RpmInstFlags zypp::ZConfig::rpmInstallFlags | ( |  | ) | const

The default target::rpm::RpmInstFlags for ZYppCommitPolicy.

Or-combination of target::rpm::RpmInstFlag.

ZConfig.instance().rpmInstallFlags().testFlag( target::rpm::RPMINST_EXCLUDEDOCS );
zypp::ZConfig::ZConfig
ZConfig(const ZConfig &)=delete
zypp::target::rpm::RPMINST_EXCLUDEDOCS
@ RPMINST_EXCLUDEDOCS
Definition RpmFlags.h:40

Definition at line 1185 of file ZConfig.cc.

## ◆ historyLogFile()

Pathname zypp::ZConfig::historyLogFile | ( |  | ) | const

Path where ZYpp install history is logged.

Defaults to /var/log/zypp/history.

See also
  http://en.opensuse.org/Libzypp/Package_History

Definition at line 1189 of file ZConfig.cc.

## ◆ credentialsGlobalDir()

Pathname zypp::ZConfig::credentialsGlobalDir | ( |  | ) | const

Defaults to /etc/zypp/credentials.d.

Definition at line 1195 of file ZConfig.cc.

## ◆ credentialsGlobalFile()

Pathname zypp::ZConfig::credentialsGlobalFile | ( |  | ) | const

Defaults to /etc/zypp/credentials.cat.

Definition at line 1200 of file ZConfig.cc.

## ◆ distroverpkg()

std::string zypp::ZConfig::distroverpkg | ( |  | ) | const

Package telling the "product version" on systems not using /etc/product.d/baseproduct.

On RHEL, Fedora and others the "product version" is determined by the first package providing 'system-release'. This value is not hardcoded in YUM and can be configured with the $distroverpkg variable.

Defaults to 'system-release'.

Definition at line 1207 of file ZConfig.cc.

## ◆ pluginsPath()

Pathname zypp::ZConfig::pluginsPath | ( |  | ) | const

Defaults to `/usr/lib/zypp/plugins`.

Definition at line 1212 of file ZConfig.cc.

## ◆ multiversionKernels()

std::string zypp::ZConfig::multiversionKernels | ( |  | ) | const

Defaults to a empty string, if no keep spec is defined no kernels are removed

Definition at line 1215 of file ZConfig.cc.

## ◆ operator=() [1/2]

ZConfig & zypp::ZConfig::operator= | ( | const ZConfig & |  | ) |
| delete

## ◆ operator=() [2/2]

ZConfig & zypp::ZConfig::operator= | ( | ZConfig && |  | ) |
| delete

## ◆ notifyTargetChanged()

void zypp::ZConfig::notifyTargetChanged | ( |  | ) |

internal

Definition at line 828 of file ZConfig.cc.

## ◆ builtinRepoCachePath()

Pathname zypp::ZConfig::builtinRepoCachePath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 971 of file ZConfig.cc.

## ◆ builtinRepoMetadataPath()

Pathname zypp::ZConfig::builtinRepoMetadataPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 974 of file ZConfig.cc.

## ◆ builtinRepoSolvfilesPath()

Pathname zypp::ZConfig::builtinRepoSolvfilesPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 977 of file ZConfig.cc.

## ◆ builtinRepoPackagesPath()

Pathname zypp::ZConfig::builtinRepoPackagesPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 980 of file ZConfig.cc.

## Friends And Related Symbol Documentation

## ◆ RepoManager

friend class RepoManager
| friend

Definition at line 638 of file ZConfig.h.

## ◆ zyppng::RepoManager

friend class zyppng::RepoManager
| friend

Definition at line 639 of file ZConfig.h.

## ◆ Impl

friend class Impl
| friend

Definition at line 650 of file ZConfig.h.

## Member Data Documentation

## ◆ _pimpl

RW_pointer<Impl, rw_pointer::Scoped<Impl> > zypp::ZConfig::_pimpl
| private

Pointer to implementation.

Definition at line 654 of file ZConfig.h.

The documentation for this class was generated from the following files:

- zypp/ZConfig.h
- zypp/solver/detail/Resolver.cc
- zypp/ZConfig.cc